#include <stdio.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include "gtkcompass.h"

void value_changed_1( GtkAdjustment *adjustment,
                    GtkWidget     *d_label )
{
  char buffer[16];
  int i;
  i=adjustment->value;
  sprintf(buffer,"%3.3d", i);
  gtk_label_set_text (GTK_LABEL (d_label), buffer);
   
}
void value_changed_2( GtkAdjustment *adjustment,
                   GtkWidget     *t_label )
{
  static char * compassPoints [32] = 
  {
      "North","N by E","NNE","NE by N","North East", "NE by E", "ENE","E by N",

      "East", "E by S", "ESE", "SE by E", "South East", "SE by S", "SSE", "S by E",

      "South", "S by W", "SSW", "SW by S", "South West", "SW by W", "WSW", "W by S",

      "West", "W by N", "WNW", "NW by W", "North West", "NW by N", "NNW", "N by W"
  };

  int j;
  j= ((adjustment->value) / 11.25); 

  gtk_label_set_text (GTK_LABEL (t_label), compassPoints[j]);
}

int main( int   argc,
          char *argv[])
{
  GtkWidget *window;
  GtkAdjustment *adjustment;
  GtkWidget *compass;
  GtkWidget *frame;
  GtkWidget *vbox;
  GtkWidget *degrees_label;
  GtkWidget * compassPointsText_label;
  
  gtk_init (&argc, &argv);

  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  
  gtk_window_set_title (GTK_WINDOW (window), "Compass");
  
  g_signal_connect (G_OBJECT (window), "destroy",
		    G_CALLBACK (exit), NULL);
  
  gtk_container_set_border_width (GTK_CONTAINER (window), 10);

  vbox = gtk_vbox_new (FALSE, 5);
  gtk_container_add (GTK_CONTAINER (window), vbox);
  gtk_widget_show (vbox);

  frame = gtk_frame_new (NULL);
  gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_IN);
  gtk_container_add (GTK_CONTAINER (vbox), frame);
  gtk_widget_show (frame); 
  GError *error = NULL;
  GdkPixbuf *pix = gdk_pixbuf_new_from_file ("abc.png", &error);
if (pix == NULL) {
    g_printerr ("Error loading file: #%d %s\n", error->code, error->message);
    g_error_free (error);
    exit (1);
}
GtkWidget *pix_widget = gtk_image_new_from_pixbuf (pix);
//gtk_container_add (GTK_CONTAINER (vbox), pix_widget);
 
  adjustment = GTK_ADJUSTMENT (gtk_adjustment_new (0, 0, 360, 1, 0.1, 0));
  
  compass = gtk_compass_new (adjustment, pix_widget);
  gtk_compass_set_update_policy (GTK_COMPASS (compass), GTK_UPDATE_DELAYED);
  /*  gtk_widget_set_size_request (compass, 100, 100); */
  
  gtk_container_add (GTK_CONTAINER (frame), compass);

  gtk_widget_show (compass);
  

  degrees_label = gtk_label_new ("0");
  compassPointsText_label = gtk_label_new("North");
  gtk_box_pack_end (GTK_BOX (vbox), degrees_label, 0, 0, 0);
  gtk_box_pack_start(GTK_BOX(vbox), compassPointsText_label,0,0,0);
  gtk_widget_show (degrees_label);
  gtk_widget_show (compassPointsText_label);

  g_signal_connect (G_OBJECT (adjustment), "value_changed",
		    G_CALLBACK (value_changed_1), (gpointer) degrees_label);
  g_signal_connect (G_OBJECT (adjustment), "value_changed",
            G_CALLBACK (value_changed_2), (gpointer) compassPointsText_label);
  
  gtk_widget_show (window);
  
  gtk_main ();
  
  return 0;
}
